# Class WebdavFixFilter

java.lang.Object
jakarta.servlet.GenericFilter
org.apache.catalina.filters.WebdavFixFilter

All Implemented Interfaces:
  `Filter`, `FilterConfig`, `Serializable`

@Deprecated public class WebdavFixFilter extends GenericFilter
Deprecated.
This will be removed in Tomcat 11 onwards. This filter is no longer required. The WebDAV client in Windows 10 / Windows Server 2012 onwards works correctly without this filter.
Filter that attempts to force MS WebDAV clients connecting on port 80 to use a WebDAV client that actually works. Other workarounds that might help include:

- Specifying the port, even if it is port 80, when trying to connect.
- Cancelling the first authentication dialog box and then trying to reconnect.

Generally each different version of the MS client has a different set of problems.

TODO: Update this filter to recognise specific MS clients and apply the appropriate workarounds for that particular client

As a filter, this is configured in web.xml like any other Filter. You usually want to map this filter to whatever your WebDAV servlet is mapped to.

In addition to the issues fixed by this Filter, the following issues have also been observed that cannot be fixed by this filter. Where possible the filter will add an message to the logs.

XP x64 SP2 (MiniRedir Version 3790)

- Only connects to port 80
- Unknown issue means it doesn't work

See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`protected static final StringManager`
`sm`
Deprecated.

## Constructor Summary

Constructors
Constructor
Description
`WebdavFixFilter()`
Deprecated.

## Method Summary

Modifier and Type
Method
Description
`void`
`doFilter(ServletRequest request, ServletResponse response, FilterChain chain)`
Deprecated.
Check for the broken MS WebDAV client and if detected issue a re-direct that hopefully will cause the non-broken client to be used.

### Methods inherited from class jakarta.servlet.GenericFilter

`getFilterConfig, getFilterName, getInitParameter, getInitParameterNames, getServletContext, init, init`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface jakarta.servlet.Filter

`destroy`

## Field Details

### sm

protected static final StringManager sm
Deprecated.

## Constructor Details

### WebdavFixFilter

public WebdavFixFilter()
Deprecated.

## Method Details

### doFilter

public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException
Deprecated.
Check for the broken MS WebDAV client and if detected issue a re-direct that hopefully will cause the non-broken client to be used.

Parameters:
  `request` - The request to process
  `response` - The response associated with the request
  `chain` - Provides access to the next filter in the chain for this filter to pass the request and response to for further processing
Throws:
  `IOException` - if an I/O error occurs during this filter's processing of the request
  `ServletException` - if the processing fails for any other reason